<?php
/**
 * @package		AdsManager
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die('Restricted access');

class AdsManagerDatetimePlugin {

	var $_db;
	
	public function getListDisplay($content,$field)
	{
		return AdsManagerDatetimePlugin::getDetailsDisplay($content,$field,$mode="list");
	}

	public function getDetailsDisplay($content,$field,$mode="details")
	{
		$fieldname = $field->name;
		$value = @$content->$fieldname;
		
		ob_start();
        ?>
            <?php echo $value; ?>
        <?php
        $content = ob_get_contents();
		ob_end_clean();
		return $content;
	}


	function needStorage() {
		return true;
	}

	function needSpecificColumnType() {
		return 'DATETIME NULL';
	}

	public function getFormDisplay($content,$field,$default=null)
	{
		$fieldname = $field->name;

		$strtitle = TText::_($field->title);
		$strtitle = htmlspecialchars($strtitle);

		$value = @$content->$fieldname;
		$options = array();
		$options['size'] = 25;
		$options['maxlength'] = 19;
		if ($field->required == 1) {
			$options['class'] = 'adsmanager_required';
			$options['mosReq'] = '1';
			$options['required'] = '1';
			$options['mosLabel'] = "$strtitle";
		}
		else 
		{
			$options['class'] = 'adsmanager';
		}
		if($value == NULL) {
            $value = '';
        }
		$return = '';
		$return .= JHTML::_('behavior.calendar');
		
		/*if ($value != "") {
			if (function_exists("strptime")) {
				$a = strptime($value, TText::_('ADSMANAGER_DATE_FORMAT_LC'));
				$timestamp = mktime(0, 0, 0, $a['tm_mon']+1, $a['tm_mday'], $a['tm_year']+1900);
			} else {
				$timestamp = strtotime($value);
			}
			if ($timestamp != null)
				$value = date("Y-m-d",$timestamp);
			else
				$value = "";
		}*/
		$return .=  JHTML::_('calendar', "", "$field->name", "$field->name", "%Y-%m-%d", $options);
		$return .= "<script type='text/javascript'>jQ(document).ready(function() {jQ('#".$field->name."').val(".json_encode($value).");jQ('#".$field->name."').attr('data-alt-value',".json_encode($value).");});</script>";
		

		return $return;
	}

	public function onFormSave($content,$field)
	{
        $date = JRequest::getVar($field->name,null);
        $date .= ' 00:00:00';
		return $date;
	}
	
	public function onDelete($directory,$contentid = -1)
	{
	}
	
	public function getEditFieldJavaScriptDisable()
	{
		$return = "elem=getObject('divDatetimeOptions');";
        $return .= "elem.style.visibility = 'hidden';";
		$return .= "elem.style.display = 'none';";
		return $return;
	}
	
	public function getEditFieldJavaScriptActive()
	{
       	$return = "disableAll();";
		$return .= "elem=getObject('divDatetimeOptions');";
        $return .= "elem.style.visibility = 'visible';";
        $return .= "elem.style.display = 'block';";
		return $return;
	}

	public function getEditFieldOptions($fieldid)
	{
		$this->install();
		$this->_db->setQuery("SELECT * FROM #__adsmanager_fields WHERE fieldid = '$fieldid'");
		$row = $this->_db->loadObject();
        if($row != null)
            $rowOptions = json_decode($row->options);
       
		$return = "<div id='divDatetimeOptions'>";
		$return .= "</div>";
		return $return;
	}

	public function saveFieldOptions($field)
	{
		$input = JFactory::getApplication()->input;
        
        $options = array();
        
        return $options;
	}
	
	public function getFieldName()
	{
		return "Datetime";
	}
	
	public function install()
	{
	}
	
	public function uninstall()
	{	
	}
	
	public function __construct()
	{
		$db	= JFactory::getDBO();
		$this->_db = $db;
	}
}
require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");
$plugins["datetime"] = new AdsManagerDatetimePlugin();