<?php
/**
 * @package		AdsManager
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die('Restricted access');

class AdsManagerRibboncornerPlugin {

	var $_db;

	public function getListDisplay($content,$field)
	{
		return AdsManagerRibboncornerPlugin::getDetailsDisplay($content,$field,$mode="list");
	}

	public function getDetailsDisplay($content,$field,$mode="details")
	{
		$fieldname = $field->name;
		$options = $field->options;

        $userField = $options->joomlafield;

        $db = JFactory::getDbo();

		$value = @$content->$fieldname;

        if($value != '') {
            
            $value = explode(';', $value);

		    ob_start();
            ?>
                <style>
				    .ribbon_<?php echo $content->id ?> {
					    background-color: <?php echo trim($value[1]); ?>;
					    overflow: hidden;
					    white-space: nowrap;
					    /* top left corner */
					    position: absolute;
					    /*left: -50px;
					    top: 40px;*/
					    /* for 45 deg rotation */
					    -webkit-transform: rotate(-45deg);
					    -moz-transform: rotate(-45deg);
					    -ms-transform: rotate(-45deg);
					    -o-transform: rotate(-45deg);
					    transform: rotate(-45deg);
					    /* for creating shadow */
					    -webkit-box-shadow: 0 0 10px #888;
					    -moz-box-shadow: 0 0 10px #888;
					    box-shadow: 0 0 10px #888;
				    }
				    .ribbon_<?php echo $content->id ?> span {
					    /*border: 1px solid #faa;*/
					    color: #fff;
					    display: block;
					    font: bold 100% 'Helvetica Neue', Helvetica, Arial, sans-serif;
					    margin: 1px 0;
					    padding: 10px 50px;
					    text-align: center;
					    text-decoration: none;
					    /* for creating shadow */
					    text-shadow: 0 0 5px #444;
					}
					

					.detailRibbon {
							display: block;
							width: 140px;
							height: 140px;
							position: absolute;
							left: -8px;
							top: -145px;
							overflow: hidden;
					}

					.detailRibbon .ribbon_<?php echo $content->id ?> {
						left: -40px;
    					top: 75px;
					    /* for 45 deg rotation */
					    -webkit-transform: rotate(45deg);
					    -moz-transform: rotate(45deg);
					    -ms-transform: rotate(45deg);
					    -o-transform: rotate(45deg);
					    transform: rotate(45deg);
					}
					
					@media(min-width: 768px) and (max-width:1152px){
						.detailRibbon {
							left: -5px;
						}
					}

					@media(min-width: 768px){
						.detailRibbon {
							left: 0px;
						}
					}
				

					.listRibbon {
						position: absolute;
						height: 100px;
						width: 100px;
						top: 32px;
						overflow: hidden;
					}

					.listRibbon .ribbon_<?php echo $content->id ?>{
						left: -52px;
    					top: 20px;
					}
			    </style>
			    <div class="ribbon_<?php echo $content->id ?>">
				    <span><?php echo trim($value[0]); ?></span>
			    </div>
            <?php
            $content = ob_get_contents();
		    ob_end_clean();
        } else {
            $content = '';
        }
		return $content;
	}

	public function getFormDisplay($content,$field,$default=null)
	{
		$fieldid = $field->fieldid;
		
		$fieldname = $field->name;
		$options = $field->options;
		$value = @$content->$fieldname;

		$availableTexts = $options->availabletexts;
        $availableTexts = explode("\n", $availableTexts);
        
		$return = '<select id="f'.$field->name.'" mosReq="'.$field->required.'" mosLabel="'.htmlspecialchars($field->title).'" name="'.$fieldname.'">
						<option value="">--</option>
                        ';
        foreach($availableTexts as $key=>$option) {
            $option = trim(preg_replace('/\s\s+/', ' ', $option));
            if($value == $option) {
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }
            $return .= '<option value="'.$option.'" '.$selected.'>'.$option.'</option>';
        }
		$return .= '</select>';
		return $return;
	}

	public function onFormSave($content,$field)
	{
		$value = JRequest::getVar($field->name,-1);
		return $value;
	}

	public function onDelete($directory,$contentid = -1)
	{
	}

	public function getEditFieldJavaScriptDisable()
	{
		$return = "elem=getObject('divRibboncornerOptions');";
        $return .= "elem.style.visibility = 'hidden';";
		$return .= "elem.style.display = 'none';";
		$return .= "elem=getObject('ribboncorner_availabletexts');";
		$return .= "elem.setAttribute('mosReq',0);";
		return $return;
	}

	public function getEditFieldJavaScriptActive()
	{
       	$return = "disableAll();";
		$return .= "elem=getObject('divRibboncornerOptions');";
        $return .= "elem.style.visibility = 'visible';";
        $return .= "elem.style.display = 'block';";
		$return .= "elem=getObject('ribboncorner_availabletexts');";
		$return .= "elem.setAttribute('mosReq',1);";
		return $return;
	}

	public function getEditFieldOptions($fieldid)
	{
		$this->install();
		$this->_db->setQuery("SELECT * FROM #__adsmanager_fields WHERE fieldid = '$fieldid'");
		$row = $this->_db->loadObject();
        if($row != null)
            $rowOptions = json_decode($row->options);

		$return = "<div id='divRibboncornerOptions'>";
		$return .= "<table class='adminform'>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Available text (NAME,color in hexadecimal)</td>";
		$return .= "<td width='20%' align=left><textarea id='ribboncorner_availabletexts' name='options_ribboncorner_availabletexts' mosReq=1 mosLabel='Available Texts' class='inputbox'>".@$rowOptions->availabletexts."</textarea></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "</table>";
		$return .= "</div>";
		return $return;
	}

	public function saveFieldOptions($field)
	{
		$availabletexts = JRequest::getVar('ribboncorner_availabletexts','');
        
        $options = array();
        $options['availabletexts'] = $availabletexts;
        
        return $options;
	}

	public function getFieldName()
	{
		return "Ribbon-corner";
	}

	public function install()
	{
	}

	public function uninstall()
	{
	}

	public function __construct()
	{
		$db	= JFactory::getDBO();
		$this->_db = $db;
	}
}
require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");
$plugins["ribboncorner"] = new AdsManagerRibboncornerPlugin();