<?php
/**
 * @package		AdsManager
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die('Restricted access');

class AdsManagerVectormapPlugin {

	var $_db;

	public function getListDisplay($content,$field)
	{
		return AdsManagerMapPlugin::getDetailsDisplay($content,$field,$mode="list");
	}

	public function getDetailsDisplay($content,$field,$mode="details")
	{
		$fieldname = $field->name;
		$fieldid = $field->fieldid;
		$options = $field->options;

		$values = $content->$fieldname;

		if(isset($options->regionbackgroundcolor) && $options->regionbackgroundcolor != '') {
			$backgroundColor = $options->regionbackgroundcolor;
		} else {
			$backgroundColor = '#FFFFFF';
		}
		if(isset($options->regioncolor) && $options->regioncolor != '') {
			$regionColor = $options->regioncolor;
		} else {
			$regionColor = '#505050';
		}
		if(isset($options->regioncolorhover) && $options->regioncolorhover != '') {
			$regionColorHover = $options->regioncolorhover;
		} else {
			$regionColorHover = '#BBBBBB';
		}
		if(isset($options->regioncolorselected) && $options->regioncolorselected != '') {
			$regionColorSelected = $options->regioncolorselected;
		} else {
			$regionColorSelected = '#FFFF00';
		}

		$mapName = str_replace('jquery-jvectormap-','',$options->mapfield);
		$mapName = str_replace('.js','',$mapName);
		$mapName = str_replace('-','_',$mapName);

		
        if($field->display_title == 1) {
            ?>
            <b><?php echo $field->title; ?> :</b>
            <?php
        }

		if(isset($options->detailsdisplaytype) && $options->detailsdisplaytype == 'map') {
            ob_start();
			$document	= JFactory::getDocument();
			$document->addStyleSheet(JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.css");
			$selectionFormats = array();
			if(!is_array($values)) {
				if($values != NULL && $values != '') {
						$origValues = $values;
						$values = json_decode($values);
						if($values == NULL) {
								$values = array();
								$values[0] = new stdClass();
								$values[0]->code = $origValues;
						}
				}
			}
			if($values != null && !empty($values)) {
				foreach($values as $selectedValue) {
					$selectionFormats[] = $selectedValue->code;
				}
			}

			$selectionFormats = json_encode($selectionFormats);
			?>
			<div id="juloa-details-vector-map<?php echo $field->name.'_'.$fieldid; ?>" style="width: 100%; height: <?php echo $options->displayviewmapheight; ?>px;"></div>
			<script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1"; ?>" type="text/javascript"></script>
			<script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$options->mapfield; ?>" type="text/javascript"></script>
			<script>
				jQuery(document).ready(function(){
					jQuery('#juloa-details-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
						map: '<?php echo $mapName; ?>',
						regionsSelectable: false,
						zoomButtons : false,
						zoomOnScroll : false,
						backgroundColor:  "<?php echo $backgroundColor; ?>",
						regionStyle: {
										initial: {
											fill: '<?php echo $regionColor; ?>',
											"fill-opacity": 1,
											stroke: 'none',
											"stroke-width": 0,
											"stroke-opacity": 1
										},
										hover: {
											"fill-opacity": 0.8,
											cursor: 'pointer',
											fill: '<?php echo $regionColorHover; ?>'
										},
										selected: {
											fill: '<?php echo $regionColorSelected; ?>'
										},
										selectedHover: {
										}
									},
						selectedRegions: <?php echo $selectionFormats; ?>,
					});
				});
			</script>
			<?php
		} else {
			ob_start();
            ?>
            <span id="juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>_span"></span>
            <div id="juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>"></div>
            <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1"; ?>" type="text/javascript"></script>
	        <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$options->mapfield; ?>" type="text/javascript"></script>
            <script type="text/javascript">
                jQuery(document).ready(function(){
                    jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
                        map: '<?php echo $mapName; ?>',
                    });
                    var juloaFieldMap = jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');
                    
					//Firefox doesn't like to display an svg in a hidden container, so we load what we need and hide the map after.
					jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').hide();

                    for (var key in juloaFieldMap.regions) {
						if(typeof juloaFieldMap.regions[key].element !== 'undefined') {
							if('<?php echo $values ?>' == juloaFieldMap.regions[key].element.config.code) {
								jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>_span').text(juloaFieldMap.regions[key].config.name);
							}
						}
                    }
                });
            </script>
            <?php
		}

        $content = ob_get_contents();
		ob_end_clean();
		return $content;
	}

	public function getValues() {
		$mapFolder = JPATH_ROOT.'/images/com_adsmanager/plugins/vectormap/vectormap/';

		$cdir = scandir($mapFolder);
		foreach ($cdir as $key => $value) {
			if (!in_array($value,array(".",".."))) {
				$maps[] = $value;
			}
		}

		return $maps;
	}

	public function getSqlFilter($fsearch, $value) {

		$values = json_decode($value);
		//$values = $value;

		if (is_int($value) || !is_array($values) && $values != '') {

			$return = " AND (a.$fsearch->name LIKE '%".$value."%')";

		} else if (is_array($values) && !empty($values)) {

			$return = " AND (";
			$i = 0;
			foreach($values as $value) {
				if($i == 0) {
					$prefix = '';
					$i++;
				} else {
					$prefix = ' OR ';
				}
				$return .= $prefix."a.$fsearch->name LIKE '%".$value->code."%'";
			}
			$return .= ")";
		} else {
			$return = '';
		}
		
		return $return;
	}

	public function getSearchFormDisplay($content,$field) {
		$document	= JFactory::getDocument();
		$document->addStyleSheet(JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.css");
		$document->addScript(JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1");

		$fieldname = $field->name;
		$options = $field->options;
		$value = $options->mapfield;
		$input = JFactory::getApplication()->input;

        $app = JFactory::getApplication();

        $view = $app->input->getCmd('view', '');

		if(isset($options->regionbackgroundcolor) && $options->regionbackgroundcolor != '') {
			$backgroundColor = $options->regionbackgroundcolor;
		} else {
			$backgroundColor = '#FFFFFF';
		}
		if(isset($options->regioncolor) && $options->regioncolor != '') {
			$regionColor = $options->regioncolor;
		} else {
			$regionColor = '#505050';
		}
		if(isset($options->regioncolorhover) && $options->regioncolorhover != '') {
			$regionColorHover = $options->regioncolorhover;
		} else {
			$regionColorHover = '#BBBBBB';
		}
		if(isset($options->regioncolorselected) && $options->regioncolorselected != '') {
			$regionColorSelected = $options->regioncolorselected;
		} else {
			$regionColorSelected = '#FFFF00';
		}

		$selectedValues = null;

		if(isset($content->$fieldname)){
			$selectedValues = json_decode($content->$fieldname);
		}

		$selectionFormats = array();
		if($selectedValues != null) {
			foreach($selectedValues as $selectedValue) {
				$selectionFormats[] = $selectedValue->code;
			}
		}

		$selectionFormats = json_encode($selectionFormats);
		
		$valueSearched = $content->$fieldname;
		
		/*if($valueSearched != '') {
			$selectionFormats = json_encode($valueSearched);
		}*/
		
		$fieldid = $field->fieldid;

		$document->addScript(JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$value);
		$mapName = str_replace('jquery-jvectormap-','',$value);
		$mapName = str_replace('.js','',$mapName);
		$mapName = str_replace('-','_',$mapName);

		$fieldname = $field->name;

        if($view == 'search') {
            $displayType = $options->searchdisplaytype;

            if($displayType == 'map') {
		        ob_start();
		        ?>
			        <div id="juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>" style="width: 100%; height: <?php echo $options->searchviewmapheight; ?>px;"></div>
			        <input type="hidden" id="search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>" name="<?php echo $field->name; ?>" value="<?php echo $selectionFormats; ?>" />
			        <script>
				        jQuery(document).ready(function(){
					        jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
						        map: '<?php echo $mapName; ?>',
						        regionsSelectable: true,
						        zoomButtons : false,
						        zoomOnScroll : false,
						        backgroundColor:  "<?php echo $backgroundColor; ?>",
						        regionStyle: {
										        initial: {
											        fill: '<?php echo $regionColor; ?>',
											        "fill-opacity": 1,
											        stroke: 'none',
											        "stroke-width": 0,
											        "stroke-opacity": 1
										        },
										        hover: {
											        "fill-opacity": 0.8,
											        cursor: 'pointer',
											        fill: '<?php echo $regionColorHover; ?>'
										        },
										        selected: {
											        fill: '<?php echo $regionColorSelected; ?>'
										        },
										        selectedHover: {
										        }
									        },
						        selectedRegions: <?php echo $selectionFormats; ?>,
						        onRegionSelected: function(e,code,isSelected,selectedRegions) {
							        var juloaFieldMap = jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');
							        var region;
							        var selection = new Array();
							        selectedRegions.forEach(function(element){
								        region = {code:element,name:juloaFieldMap.getRegionName(element)};
								        selection.push(region);
							        });
							        jQuery('#search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>').val(JSON.stringify(selection));
						        },
					        });
				        });
			        </script>
		        <?php
            } else {
                ob_start();
                ?>
                <select id="search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>_select" name="search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>">
                    
                </select>
                <div id="juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>"></div>
                <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1"; ?>" type="text/javascript"></script>
		        <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$value; ?>" type="text/javascript"></script>
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
                            map: '<?php echo $mapName; ?>',
                        });
                        var juloaFieldMap = jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');
                        
						//Firefox doesn't like to display an svg in a hidden container, so we load what we need and hide the map after.
						jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').hide();
						
						var regions = jQ.map(juloaFieldMap.regions, function(value, index) {
                            return [value];
                        });
                        regions.sort(function(a,b) {if(a.config.name < b.config.name) return -1;
                                                     if(a.config.name > b.config.name) return 1;
                                                     return 0;});

                        for (var key in regions) {
							if(typeof regions[key].element !== 'undefined') {
								jQuery('#search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>_select').append(jQuery('<option>', {
									value: regions[key].element.config.code,
									text: regions[key].config.name
								}));
							}
                        }
                    });
                </script>
                <?php
            }
        } else {
            $displayType = $options->searchmoduledisplaytype;

            if($displayType == 'map') {
		        ob_start();
		        ?>
			        <div id="juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>" style="width: 100%; height: <?php echo $options->searchviewmapheight; ?>px;"></div>
			        <input type="hidden" id="search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>" name="<?php echo $field->name; ?>" value="<?php echo $selectionFormats; ?>" />
			        <script>
				        jQuery(document).ready(function(){
					        jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
						        map: '<?php echo $mapName; ?>',
						        regionsSelectable: true,
						        zoomButtons : false,
						        zoomOnScroll : false,
						        backgroundColor:  "<?php echo $backgroundColor; ?>",
						        regionStyle: {
										        initial: {
											        fill: '<?php echo $regionColor; ?>',
											        "fill-opacity": 1,
											        stroke: 'none',
											        "stroke-width": 0,
											        "stroke-opacity": 1
										        },
										        hover: {
											        "fill-opacity": 0.8,
											        cursor: 'pointer',
											        fill: '<?php echo $regionColorHover; ?>'
										        },
										        selected: {
											        fill: '<?php echo $regionColorSelected; ?>'
										        },
										        selectedHover: {
										        }
									        },
						        selectedRegions: <?php echo $selectionFormats; ?>,
						        onRegionSelected: function(e,code,isSelected,selectedRegions) {
							        var juloaFieldMap = jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');
							        var region;
							        var selection = new Array();
							        selectedRegions.forEach(function(element){
								        region = {code:element,name:juloaFieldMap.getRegionName(element)};
								        selection.push(region);
							        });
							        jQuery('#search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>').val(JSON.stringify(selection));
						        },
					        });
				        });
			        </script>
		        <?php
            } else {
                ob_start();
				
                ?>
                <select id="search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>_select" name="<?php echo $field->name; ?>">
                    <option value="">--</option>
                </select>
                <div id="juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>"></div>
                <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1"; ?>" type="text/javascript"></script>
		        <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$value; ?>" type="text/javascript"></script>
                <script type="text/javascript">
                    jQuery(document).ready(function(){
                        jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
                            map: '<?php echo $mapName; ?>',
                        });
                        var juloaFieldMap = jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');
                        
						//Firefox doesn't like to display an svg in a hidden container, so we load what we need and hide the map after.
						jQuery('#juloa-search-vector-map<?php echo $field->name.'_'.$fieldid; ?>').hide();
						
						var regions = jQ.map(juloaFieldMap.regions, function(value, index) {
                            return [value];
                        });
                        regions.sort(function(a,b) { if(a.config.name < b.config.name) return -1;
                                                     if(a.config.name > b.config.name) return 1;
                                                     return 0;});

                        for (var key in regions) {
							if(typeof regions[key].element !== 'undefined') {
								jQuery('#search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>_select').append(jQuery('<option>', {
									value: regions[key].element.config.code,
									text: regions[key].config.name
								}));
								
								if('<?php echo $valueSearched ?>' == regions[key].element.config.code) {
									jQuery('#search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>_select').val(regions[key].element.config.code);
								}
							}
						}
						jQuery('#search-vectormap_<?php echo $field->name.'_'.$fieldid; ?>_select').val('<?php echo $valueSearched?>');
                    });
                </script>
                <?php
            }
        }
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}

	public function getFormDisplay($content,$field,$default=null)
	{
		$document	= JFactory::getDocument();
		$document->addStyleSheet(JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.css");
		//$document->addScript(JURI::root()."images/com_adsmanager/plugins/map/jquery-jvectormap-2.0.3.min.js");

		$fieldname = $field->name;
		$options = $field->options;
		$value = $options->mapfield;

		if(isset($options->regionbackgroundcolor) && $options->regionbackgroundcolor != '') {
			$backgroundColor = $options->regionbackgroundcolor;
		} else {
			$backgroundColor = '#FFFFFF';
		}
		if(isset($options->regioncolor) && $options->regioncolor != '') {
			$regionColor = $options->regioncolor;
		} else {
			$regionColor = '#505050';
		}
		if(isset($options->regioncolorhover) && $options->regioncolorhover != '') {
			$regionColorHover = $options->regioncolorhover;
		} else {
			$regionColorHover = '#BBBBBB';
		}
		if(isset($options->regioncolorselected) && $options->regioncolorselected != '') {
			$regionColorSelected = $options->regioncolorselected;
		} else {
			$regionColorSelected = '#FFFF00';
		}

        $displayType = $options->formdisplaytype;

		$selectedValues = null;

		if(isset($content->$fieldname)){
			$selectedValues = json_decode($content->$fieldname);
		}

		$selectionFormats = array();
		if($selectedValues != null) {
			foreach($selectedValues as $selectedValue) {
				$selectionFormats[] = $selectedValue->code;
			}
		}

		$values = '';

		if(isset($content->$fieldname)) {
			$values = $content->$fieldname;
		}
    
		$selectionFormats = json_encode($selectionFormats);

		$fieldid = $field->fieldid;

		//$document->addScript(JURI::root()."images/com_adsmanager/plugins/map/map/".$value);
		$mapName = str_replace('jquery-jvectormap-','',$value);
		$mapName = str_replace('.js','',$mapName);
		$mapName = str_replace('-','_',$mapName);
		$fieldname = $field->name;

        if($displayType == 'map') {
		    ob_start();
		    ?>
			    <div id="juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>" style="width: 100%; height: <?php echo $options->editviewmapheight; ?>px;"></div>
			    <input type="hidden" id="edit-vectormap_<?php echo $field->name.'_'.$fieldid; ?>" name="vectormap_<?php echo $field->name.'_'.$fieldid; ?>" value="<?php echo $selectionFormats; ?>" />
			    <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1"; ?>" type="text/javascript"></script>
			    <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$value; ?>" type="text/javascript"></script>
			    <script>
				    jQuery(document).ready(function(){
					    jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
						    map: '<?php echo $mapName; ?>',
						    regionsSelectable: true,
						    zoomButtons : false,
						    zoomOnScroll : false,
						    backgroundColor:  "<?php echo $backgroundColor; ?>",
						    regionStyle: {
										    initial: {
											    fill: '<?php echo $regionColor; ?>',
											    "fill-opacity": 1,
											    stroke: 'none',
											    "stroke-width": 0,
											    "stroke-opacity": 1
										    },
										    hover: {
											    "fill-opacity": 0.8,
											    cursor: 'pointer',
											    fill: '<?php echo $regionColorHover; ?>'
										    },
										    selected: {
											    fill: '<?php echo $regionColorSelected; ?>'
										    },
										    selectedHover: {
										    }
									    },
						    selectedRegions: <?php echo $selectionFormats; ?>,
						    onRegionSelected: function(e,code,isSelected,selectedRegions) {
							    var juloaFieldMap = jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');
							    var region;
							    var selection = new Array();
							    selectedRegions.forEach(function(element){
								    region = {code:element,name:juloaFieldMap.getRegionName(element)};
								    selection.push(region);
							    });
							    jQuery('#edit-vectormap_<?php echo $field->name.'_'.$fieldid; ?>').val(JSON.stringify(selection));
						    },
						    regionsSelectableOne: true,
					    });
				    });
			    </script>
		    <?php
        } else {
            ob_start();
            ?>
            <select id="juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>_select" name="vectormap_<?php echo $field->name.'_'.$fieldid; ?>">
                
            </select>
            <div id="juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>"></div>
            <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/jquery-jvectormap-2.0.3.min.js?1"; ?>" type="text/javascript"></script>
		    <script src="<?php echo JURI::root()."images/com_adsmanager/plugins/vectormap/vectormap/".$value; ?>" type="text/javascript"></script>
            <script type="text/javascript">
                jQuery(document).ready(function(){
                    jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap({
                        map: '<?php echo $mapName; ?>',
                    });
                    var juloaFieldMap = jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').vectorMap('get', 'mapObject');

					//Firefox doesn't like to display an svg in a hidden container, so we load what we need and hide the map after.
					jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>').hide();

                    var regions = jQ.map(juloaFieldMap.regions, function(value, index) {
                        return [value];
                    });
                    regions.sort(function(a,b) { if(a.config.name < b.config.name) return -1;
                                                     if(a.config.name > b.config.name) return 1;
                                                     return 0;});
                    for (var key in regions) {
						if(typeof regions[key].element !== 'undefined') {
							jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>_select').append(jQuery('<option>', {
								value: regions[key].element.config.code,
								text: regions[key].config.name
							}));

							if('<?php echo $values ?>' == regions[key].element.config.code) {
								jQuery('#juloa-edit-vector-map<?php echo $field->name.'_'.$fieldid; ?>_select').val(regions[key].element.config.code);
							}
						}
                    }
                });
            </script>
            <?php
        }
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}

	public function onFormSave($content,$field)
	{
		$input = JFactory::getApplication()->input;
		$value = $input->get('vectormap_'.$field->name.'_'.$field->fieldid,'','string');
		return $value;
	}

	public function onDelete($directory,$contentid = -1)
	{
	}

	public function getEditFieldJavaScriptDisable()
	{
		$return = "elem=getObject('divVectorMapOptions');";
        $return .= "elem.style.visibility = 'hidden';";
		$return .= "elem.style.display = 'none';";
		$return .= "elem=getObject('map_mapfield');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regionbackgroundcolor');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regioncolor');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regioncolorhover');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regioncolorselected');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_detailsdisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_displayviewmapheight');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_searchviewmapheight');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_editviewmapheight');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_formdisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_searchdisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_searchmoduledisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		return $return;
	}

	public function getEditFieldJavaScriptActive()
	{
       	$return = "disableAll();";
		$return .= "elem=getObject('divVectorMapOptions');";
        $return .= "elem.style.visibility = 'visible';";
        $return .= "elem.style.display = 'block';";
		$return .= "elem=getObject('map_mapfield');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('map_displayviewmapheight');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('map_searchviewmapheight');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('map_editviewmapheight');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('map_regionbackgroundcolor');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regioncolor');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regioncolorhover');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_regioncolorselected');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_detailsdisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_formdisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_searchdisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('map_searchmoduledisplaytype');";
		$return .= "elem.setAttribute('mosReq',0);";
		return $return;
	}

	public function getEditFieldOptions($fieldid)
	{
		$this->install();
		$this->_db->setQuery("SELECT * FROM #__adsmanager_fields WHERE fieldid = '$fieldid'");
		$row = $this->_db->loadObject();
        if($row != null)
            $rowOptions = json_decode($row->options);

        $maps = $this->getValues();
		$mapsList = array();
        if (isset($maps))
		{
			foreach($maps as $map)
			{

				$mapsList[] = JHTML::_('select.option', $map, $map );
			}
		}
        $lists['mapsfields'] = JHTML::_('select.genericlist', $mapsList, 'map_mapfield', 'class="inputbox" size="1"', 'value', 'text', @$rowOptions->mapfield );

		$formDisplayTypes = array();
		$formDisplayTypes[] = JHTML::_('select.option', 'map', 'Map' );
		$formDisplayTypes[] = JHTML::_('select.option', 'select', 'Select' );
		$lists['formdisplaytype'] = JHTML::_('select.genericlist', $formDisplayTypes, 'map_formdisplaytype', 'class="inputbox" size="1"', 'value', 'text', @$rowOptions->formdisplaytype );

		$searchDisplayTypes = array();
		$searchDisplayTypes[] = JHTML::_('select.option', 'map', 'Map' );
		$searchDisplayTypes[] = JHTML::_('select.option', 'select', 'Select' );
		$lists['searchdisplaytype'] = JHTML::_('select.genericlist', $searchDisplayTypes, 'map_searchdisplaytype', 'class="inputbox" size="1"', 'value', 'text', @$rowOptions->searchdisplaytype );

		$detailsDisplayTypes = array();
		$detailsDisplayTypes[] = JHTML::_('select.option', 'list', 'List' );
		$detailsDisplayTypes[] = JHTML::_('select.option', 'map', 'Map' );
		$lists['detailsdisplaytype'] = JHTML::_('select.genericlist', $detailsDisplayTypes, 'map_detailsdisplaytype', 'class="inputbox" size="1"', 'value', 'text', @$rowOptions->detailsdisplaytype );

        $searchModuleDisplayTypes = array();
		$searchModuleDisplayTypes[] = JHTML::_('select.option', 'map', 'Map' );
		$searchModuleDisplayTypes[] = JHTML::_('select.option', 'select', 'Select' );
		$lists['searchmoduledisplaytype'] = JHTML::_('select.genericlist', $searchModuleDisplayTypes, 'map_searchmoduledisplaytype', 'class="inputbox" size="1"', 'value', 'text', @$rowOptions->searchmoduledisplaytype );

		$return = "<div id='divVectorMapOptions'>";
		$return .= "<table class='adminform'>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map</td>";
		$return .= "<td width='20%' align=left>".$lists['mapsfields']."</td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td colspan='3'>
						You can download a map at <a href='http://jvectormap.com/maps/countries/france-regions/' target='_blank'>jvectormap.com</a>.<br />
						Select a country in the left column, then do a right click on the download link just below the map and click on 'Save link as...'<br />
						Then, upload the map on your server in images/com_adsmanager/plugins/vectormap/vectormap/. Do not rename the map !<br />
						Reload this page and the map will appear in the list.<br /><br />
					</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Display view map height</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_displayviewmapheight' name='map_displayviewmapheight' class='inputbox' value='".@$rowOptions->displayviewmapheight."' /></td>";
		$return .= "<td>in pixel</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Search view map height</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_searchviewmapheight' name='map_searchviewmapheight' class='inputbox' value='".@$rowOptions->searchviewmapheight."' /></td>";
		$return .= "<td>in pixel</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Edit view map height</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_editviewmapheight' name='map_editviewmapheight' class='inputbox' value='".@$rowOptions->editviewmapheight."' /></td>";
		$return .= "<td>in pixel</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map Regions Background Color</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_regionbackgroundcolor' name='map_regionbackgroundcolor' class='inputbox' value='".@$rowOptions->regionbackgroundcolor."' /></td>";
		$return .= "<td>in hexadecimal</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map Regions Color</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_regioncolor' name='map_regioncolor' class='inputbox' value='".@$rowOptions->regioncolor."' /></td>";
		$return .= "<td>in hexadecimal</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map Regions Color on hover</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_regioncolorhover' name='map_regioncolorhover' class='inputbox' value='".@$rowOptions->regioncolorhover."' /></td>";
		$return .= "<td>in hexadecimal</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Map Regions Color on selected</td>";
		$return .= "<td width='20%' align=left><input type='text' id='map_regioncolorselected' name='map_regioncolorselected' class='inputbox' value='".@$rowOptions->regioncolorselected."' /></td>";
		$return .= "<td>in hexadecimal</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Details display type</td>";
		$return .= "<td width='20%' align=left>".$lists['detailsdisplaytype']."</td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Write ad Form display type</td>";
		$return .= "<td width='20%' align=left>".$lists['formdisplaytype']."</td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Search display type</td>";
		$return .= "<td width='20%' align=left>".$lists['searchdisplaytype']."</td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Search Module display type</td>";
		$return .= "<td width='20%' align=left>".$lists['searchmoduledisplaytype']."</td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "</table>";
		$return .= "</div>";
		return $return;
	}

	public function saveFieldOptions($field)
	{
		$mapfield = JRequest::getVar('map_mapfield','-1','string');
		$regionbackgroundcolor = JRequest::getVar('map_regionbackgroundcolor','','string');
		$regioncolor = JRequest::getVar('map_regioncolor','','string');
		$regioncolorhover = JRequest::getVar('map_regioncolorhover','','string');
		$regioncolorselected = JRequest::getVar('map_regioncolorselected','','string');
		$formdisplaytype = JRequest::getVar('map_formdisplaytype','map','string');
		$searchdisplaytype = JRequest::getVar('map_searchdisplaytype','map','string');
		$searchmoduledisplaytype = JRequest::getVar('map_searchmoduledisplaytype','map','string');
		$detailsdisplaytype = JRequest::getVar('map_detailsdisplaytype','list','string');
		$displayviewmapheight = JRequest::getVar('map_displayviewmapheight','400','integer');
		$searchviewmapheight = JRequest::getVar('map_searchviewmapheight','400','integer');
		$editviewmapheight = JRequest::getVar('map_editviewmapheight','400','integer');

        $options = array();
        $options['mapfield'] = $mapfield;
		$options['regionbackgroundcolor'] = $regionbackgroundcolor;
		$options['regioncolor'] = $regioncolor;
		$options['regioncolorhover'] = $regioncolorhover;
		$options['regioncolorselected'] = $regioncolorselected;
        $options['formdisplaytype'] = $formdisplaytype;
        $options['searchdisplaytype'] = $searchdisplaytype;
        $options['searchmoduledisplaytype'] = $searchmoduledisplaytype;
        $options['detailsdisplaytype'] = $detailsdisplaytype;
        $options['displayviewmapheight'] = $displayviewmapheight;
        $options['searchviewmapheight'] = $searchviewmapheight;
        $options['editviewmapheight'] = $editviewmapheight;

        return $options;
	}

	public function getFieldName()
	{
		return "Vectormap";
	}

	public function install()
	{
	}

	public function uninstall()
	{
	}

	public function __construct()
	{
		$db	= JFactory::getDBO();
		$this->_db = $db;
	}
}
require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");
$plugins["vectormap"] = new AdsManagerVectormapPlugin();
