<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// no direct access
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/configuration.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/content.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/field.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/user.php');
require_once(JPATH_BASE."/components/com_adsmanager/helpers/field.php");

$uri = JFactory::getURI();
$baseurl = JURI::base();
$catid = JRequest::getInt('catid',0);
$document = JFactory::getDocument();
$app = JFactory::getApplication();
loadAdsManagerCss();

$document = JFactory::getDocument();
$document->addScript(JURI::root().'components/com_adsmanager/js/jquery.cookie.js');

$confmodel  = new AdsmanagerModelConfiguration();
$conf = $confmodel->getConfiguration();

$limitstart = JRequest::getInt("limitstart",0);
$limit = $conf->ads_per_page;

$order = $app->getUserStateFromRequest('com_adsmanager.front_content.order','order',0,'int');
$orderdir = $app->getUserStateFromRequest('com_adsmanager.front_content.orderdir','orderdir','DESC');
$orderdir = strtoupper($orderdir);
if (($orderdir != "DESC") && ($orderdir != "ASC")) {
	$orderdir = "DESC";
}

$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));

if($params->get('map_field') !== null) {
	//param map
	$mapDisplayAllAds = intval($params->get('map_display_all_ads', 0));
	$mapField = htmlspecialchars($params->get('map_field', 'ad_gmap'));
	$mapHide = intval($params->get('map_hide', 0));
	$mapLinkAds = intval($params->get('map_link_ads', 0));
	$mapDisplayTitle = intval($params->get('map_display_title', 1));
	$mapEnableLinkTitle = intval($params->get('map_enable_link_title', 1));
	$mapDisplayImage = intval($params->get('map_display_image', 1));
	$mapDisplayDescription = intval($params->get('map_display_description', 1));
	$mapDisplayPrice = intval($params->get('map_display_price', 1));
	$mapFieldPrice = htmlspecialchars($params->get('map_field_price', 'ad_price'));
	$mapHeight = intval($params->get('map_height', 400));
	$mapDefaultLat = floatval($params->get('map_default_lat', 48.85719913498834));
	$mapDefaultLng = floatval($params->get('map_default_lng', 2.33935546875));
	$mapDefaultZoom = intval($params->get('map_default_zoom', 6));
}

//We prevent the case if the height is at 0
if($mapHeight == 0) {
	$mapHeight = 400;
}

$contentmodel  = new AdsmanagerModelContent();
$filter_order = $contentmodel->getFilterOrder($order);
$filter_order_dir = $orderdir;

$filters = array();
$currentSession = JSession::getInstance('none',array());
$filters['fields'] = $currentSession->get("searchfieldssql"," 1 ");
$catid = $app->getUserStateFromRequest( 'searchfieldscatid','catid',0,'integer' );
//need to check if the last line is correct, one client has trouble with it.
//the catid is not correct
if($catid == 0) {
    $catid = $currentSession->get( 'searchfieldscatid',0 );
}
if ($catid != 0)
	$filters['category'] = $catid;

$rootid = (int)$params->get( 'rootid', 0) ;
if ($rootid !== null) {
	$filters['rootid'] = $rootid;
}

//Taking account of the search field on the list
$listuser = JRequest::getInt( 'user',	-1 );
if (($listuser == 0)&&($user->id != 0))
    $listuser = $user->id;

$usermodel = new AdsmanagerModelUser();
if ($listuser != -1) {
    $filters['user'] = $listuser;
    $user = $usermodel->getUser($listuser);
    if(!isset($category)) {
        $category = new stdClass();
    }
    if ($conf->display_fullname) {
        $category->name = JText::_('ADSMANAGER_LIST_USER_TEXT')." ".$user->name;
    } else {
        $category->name = JText::_('ADSMANAGER_LIST_USER_TEXT')." ".$user->username;
    }
    $modeuser = 1;
}
$session = JFactory::getSession();
$list_type = $session->get('list_type','','adsmanager');
$list_value = $session->get('list_value','','adsmanager');

if ($listuser != -1) {
    if (($list_type == 'user')&&($list_value == $listuser)) {
        $tsearch = JRequest::getVar( 'tsearch',	$session->get('tsearch','','adsmanager'));
        $session->set('tsearch',$tsearch,'adsmanager');
    } else {
        $session->set('list_type','user','adsmanager');
        $session->set('list_value',$listuser,'adsmanager');
        $session->set('tsearch','','adsmanager');
        $tsearch = '';
    }
} else {
    if (($list_type == 'category')&&($list_value == $catid)) {
        $tsearch = JRequest::getVar( 'tsearch',	$session->get('tsearch','','adsmanager'));
        $session->set('tsearch',$tsearch,'adsmanager');
    } else {
        $session->set('list_type','category','adsmanager');
        $session->set('list_value',$catid,'adsmanager');
        $session->set('tsearch','','adsmanager');
        $tsearch = '';
    }
}

if ($tsearch != "")
{
    $filters['search'] = $tsearch;
}

if(isset($mapDisplayAllAds) && $mapDisplayAllAds == 1) {
    $filters = array();
    $limitstart = null;
    $limit = null;
    $filter_order = null;
    $filter_order_dir = null;
}

$total = $contentmodel->getNbContents($filters);

$db = JFactory::getDbo();

$query = "SELECT * FROM #__adsmanager_fields WHERE type = 'gmap'";
$db->setQuery($query);
$result = $db->loadObject();

if($result != null){

	/*if (isset($filters['fields']) && ($filters['fields'] != ""))
    	$filters['fields'] .= " AND (a.ad_gmap_lat != '' ";*/

    $contents = $contentmodel->getContents($filters,$limitstart, $limit,$filter_order,$filter_order_dir);

} else {
    $contents = array();
}

$fieldmodel  = new AdsmanagerModelField();
$field_values = $fieldmodel->getFieldValues();
$field = new JHTMLAdsmanagerField($conf,$field_values,"4",$fieldmodel->getPlugins());

$fieldsArray = array($mapFieldPrice);
/*$fieldsArray[] = $params->get( 'field1', "") ;
$fieldsArray[] = $params->get( 'field2', "") ;
$fieldsArray[] = $params->get( 'field3', "") ;
$fieldsArray[] = $params->get( 'field4', "") ;
$fieldsArray[] = $params->get( 'field5', "") ;*/
$listfields="";
foreach($fieldsArray as $field)
{
	if (($listfields == "")&&($field != ""))
		$listfields .= "'$field'";
	if ($field != "")
		$listfields .= ",'$field'";
}

$field_values = array();
$adfields = array();
if ($listfields != "")
{
	$adfields = $fieldmodel->getFieldsByName($listfields);
	$field_values = $fieldmodel->getFieldValues();

	foreach($adfields as $field)
	{
		if ($field->cbfieldvalues != "-1")
		{
			/*get CB value fields */
			$cbfieldvalues = $fieldmodel->getCBFieldValues($field->cbfieldvalues);
			$field_values[$field->fieldid] = $cbfieldvalues;
		}
	}
}

if(isset($adfields[$mapFieldPrice])) {
	$fieldPrice = $adfields[$mapFieldPrice];
}

if ($rootid!=0) {
	$urlparamroot = "&rootid=$rootid";
} else {
	$urlparamroot = "";
}

$markers = array();
$latlon = array();
foreach($contents as $content) {
    $link = TRoute::_("index.php?option=com_adsmanager&view=details$urlparamroot&id=".$content->id."&catid=".$content->catid);
    $title = $content->ad_headline;
    $price = $content->$mapFieldPrice;
    if ($price != "") {
    	if(isset($fieldPrice)) {
	        if($fieldPrice->options == null || $fieldPrice->options->currency_symbol == '')
	            $price = sprintf(JText::_('ADSMANAGER_CURRENCY'),number_format(floatval($price), 2, '.', ' '));
	        else
	            $price = JHTMLAdsmanagerField::formatPrice($price, $fieldPrice->options);
    	} else {
    		$price = '';
    	}
        //for Right to Left language
        $price = str_replace(" ","&nbsp;",$price);
    }
    $description = JString::substr($content->ad_text, 0, 140)."[...]";
    if ((count($content->images) > 0)&&(@$content->images[0]->thumbnail)) {
        $image = JURI_IMAGES_FOLDER."/".$content->images[0]->thumbnail;
    } else {
        $image = ADSMANAGER_NOPIC_IMG;
	}

	$lat = $mapField."_lat";
	$lng = $mapField."_lng";

    if($content->$lat == 0)
		continue;
    if($content->published == 0)
		continue;

    //If the latlon already exist, we move the marker a little (rand to have unique position)
    if(in_array("{$content->$lat}"."{$content->$lng}", $latlon)){
        $content->$lat = $content->$lat + (rand(0, 1000) / 10000000);
    }

    $latlon[] = "{$content->$lat}"."{$content->$lng}";

    $markers[] = array('image' => $image,
                       'description'=>$description,
                       'lat'=>$content->$lat,
                       'lon'=>$content->$lng,
                       'title'=>$title,
                       'link'=>$link,
                       'price'=>$price
                       );

}

$db->setQuery("SELECT google_key FROM #__adsmanager_fieldgmap_conf WHERE google_key IS NOT NULL");
$googleKey = $db->loadResult();
if ($googleKey == false)
	$googleKey = "";

require(JModuleHelper::getLayoutPath('mod_adsmanager_adsmap',$params->get( 'layout','default')));

$content="";
$path = JPATH_ADMINISTRATOR.'/../libraries/joomla/database/table';
JTable::addIncludePath($path);

?>
